using System;
using System.Linq;
using System.Collections.ObjectModel;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using SmartX;
using INT51DB.Forms;
using INT51DB.DialogForms;

namespace INT51DB.Controls
{
    public partial class ControlBottomEquipment : UserControl
    {
        #region Field
        private FormMenu m_ParentForm;

        private DataStore.MenuBottomEquipment CurrentMenu;
        private Collection<SmartButton> CollectionButtonMenu;
        #endregion

        #region Constructor
        public ControlBottomEquipment(FormMenu parent)
        {
            InitializeComponent();

            this.ParentForm = parent;

            this.InitializeDesign();
            this.DefaultSetting();
        }
        #endregion

        #region Property
        public FormMenu ParentForm
        {
            get { return this.m_ParentForm; }
            private set { this.m_ParentForm = value; }
        }
        #endregion

        #region Method
        public void InitializeDesign()
        {
        }
        private void DefaultSetting()
        {
            this.CurrentMenu = DataStore.MenuBottomEquipment.Help;

            this.CollectionButtonMenu = new Collection<SmartButton>();
            this.CollectionButtonMenu.Clear();
            this.CollectionButtonMenu.Add(this.buttonHelp);
            this.CollectionButtonMenu.Add(this.buttonInitialize);
            this.CollectionButtonMenu.Add(this.buttonUpdate);
            this.CollectionButtonMenu.Add(this.buttonUser);
            this.CollectionButtonMenu.Add(this.buttonTest);
        }

        public void CurrentControlEnable(bool enable)
        {
            foreach (SmartButton button in this.CollectionButtonMenu)
                button.Enabled = enable;
        }

        public void UpdateDisplayMenuButton(DataStore.MenuBottomEquipment menu)
        {
            switch (menu)
            {
                case DataStore.MenuBottomEquipment.FunctionSetting:
                    if (this.buttonFuctionSetting.ButtonStatus != SmartButton.BUTSTATUS.DOWN)
                        this.buttonFuctionSetting.ButtonDown();
                    if (this.buttonHelp.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonHelp.ButtonUp();
                    if (this.buttonInitialize.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonInitialize.ButtonUp();
                    if (this.buttonTest.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonTest.ButtonUp();
                    if (this.buttonUpdate.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonUpdate.ButtonUp();
                    if (this.buttonUser.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonUser.ButtonUp();
                    break;
                case DataStore.MenuBottomEquipment.Help:
                    if (this.buttonFuctionSetting.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonFuctionSetting.ButtonUp();
                    if (this.buttonHelp.ButtonStatus != SmartButton.BUTSTATUS.DOWN)
                        this.buttonHelp.ButtonDown();
                    if (this.buttonInitialize.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonInitialize.ButtonUp();
                    if (this.buttonTest.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonTest.ButtonUp();
                    if (this.buttonUpdate.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonUpdate.ButtonUp();
                    if (this.buttonUser.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonUser.ButtonUp();
                    break;
                case DataStore.MenuBottomEquipment.Initialize:
                    if (this.buttonFuctionSetting.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonFuctionSetting.ButtonUp();
                    if (this.buttonHelp.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonHelp.ButtonUp();
                    if (this.buttonInitialize.ButtonStatus != SmartButton.BUTSTATUS.DOWN)
                        this.buttonInitialize.ButtonDown();
                    if (this.buttonTest.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonTest.ButtonUp();
                    if (this.buttonUpdate.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonUpdate.ButtonUp();
                    if (this.buttonUser.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonUser.ButtonUp();
                    break;
                case DataStore.MenuBottomEquipment.Test:
                    if (this.buttonFuctionSetting.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonFuctionSetting.ButtonUp();
                    if (this.buttonHelp.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonHelp.ButtonUp();
                    if (this.buttonInitialize.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonInitialize.ButtonUp();
                    if (this.buttonTest.ButtonStatus != SmartButton.BUTSTATUS.DOWN)
                        this.buttonTest.ButtonDown();
                    if (this.buttonUpdate.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonUpdate.ButtonUp();
                    if (this.buttonUser.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonUser.ButtonUp();
                    break;
                case DataStore.MenuBottomEquipment.Update:
                    if (this.buttonFuctionSetting.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonFuctionSetting.ButtonUp();
                    if (this.buttonHelp.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonHelp.ButtonUp();
                    if (this.buttonInitialize.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonInitialize.ButtonUp();
                    if (this.buttonTest.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonTest.ButtonUp();
                    if (this.buttonUpdate.ButtonStatus != SmartButton.BUTSTATUS.DOWN)
                        this.buttonUpdate.ButtonDown();
                    if (this.buttonUser.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonUser.ButtonUp();
                    break;
                case DataStore.MenuBottomEquipment.User:
                    if (this.buttonFuctionSetting.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonFuctionSetting.ButtonUp();
                    if (this.buttonHelp.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonHelp.ButtonUp();
                    if (this.buttonInitialize.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonInitialize.ButtonUp();
                    if (this.buttonTest.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonTest.ButtonUp();
                    if (this.buttonUpdate.ButtonStatus != SmartButton.BUTSTATUS.UP)
                        this.buttonUpdate.ButtonUp();
                    if (this.buttonUser.ButtonStatus != SmartButton.BUTSTATUS.DOWN)
                        this.buttonUser.ButtonDown();
                    break;
                default:
                    break;
            }
        }

        public void DisplayRefresh(DataStore.UserGroup group)
        {
            this.buttonHelp.ButtonDown();
            this.buttonUpdate.ButtonUp();
            this.buttonInitialize.ButtonUp();
            this.buttonFuctionSetting.ButtonUp();
            this.buttonUser.ButtonUp();
            this.buttonTest.ButtonUp();

            this.CurrentMenu = DataStore.MenuBottomEquipment.Help;
            this.ParentForm.DisplayBottomEquipment(this.CurrentMenu);
        }
        #endregion

        #region Event Handler
        private void buttonMenu_Click(object sender, EventArgs e)
        {
            SmartButton button = sender as SmartButton;

            if (button == null)
                return;

            if (button == this.buttonHelp)
                this.CurrentMenu = DataStore.MenuBottomEquipment.Help;
            else if (button == this.buttonUpdate)
                this.CurrentMenu = DataStore.MenuBottomEquipment.Update;
            else if (button == this.buttonInitialize)
                this.CurrentMenu = DataStore.MenuBottomEquipment.Initialize;
            else if (button == this.buttonFuctionSetting)
                this.CurrentMenu = DataStore.MenuBottomEquipment.FunctionSetting;
            else if (button == this.buttonUser)
                this.CurrentMenu = DataStore.MenuBottomEquipment.User;
            else if (button == this.buttonTest)
                this.CurrentMenu = DataStore.MenuBottomEquipment.Test;
            else
                this.CurrentMenu = DataStore.MenuBottomEquipment.Help;

            this.ParentForm.DisplayBottomEquipment(this.CurrentMenu);
        }
        #endregion
    }
}
